-- WMA Converter.applescript
-- WMA Converter

--  Created by Matthew Hutton on 13/05/2006.
--  Copyright 2006 __MyCompanyName__. All rights reserved.
property importMP3 : false
property mainRunning : false
property deleteSource : false
property FilesNotFolders : 0
property SubFolders : false
property theInFolder : ""
property theinfile : ""
property theOutFolder : ""
property WMACounter : 0
property bitrate : 128
property theVal : 3.0
global iTunesLibraryPl
on clicked theObject
	set theName to the name of theObject
	if theName starts with "Choose" then
		if theName is "Choose Input Folder" then
			set theInFolder to choose folder with prompt "Choose Folder which contains input files"
			set theInFolder to theInFolder as string
			set the contents of text field "Input Folder String" of box "IFBox" of tab view item "Folders" of tab view "Tabs" of window "Window" to theInFolder
		else if theName is "Choose Input File" then
			set theinfile to choose file with prompt "Choose the file to convert" without invisibles
			set theinfile to theinfile as string
			set the contents of text field "Input File String" of box "IFBox" of tab view item "Files" of tab view "Tabs" of window "Window" to theinfile
		else if theName is "Choose Output Folder" then
			set theOutFolder to choose folder with prompt "Choose Folder to save output to"
			set theOutFolder to theOutFolder as string
			set the contents of text field "Output Folder String" of box "OFBox" of window "Window" to theOutFolder
		end if
	else if theName is "Import MP3" then
		set importMP3 to the state of theObject
	else if theName is "Delete Source" then
		set deleteSource to the state of theObject
	else if theName is "Include Sub-Folders" then
		set SubFolders to the state of theObject
	else if theName is "Convert" then
		if mainRunning is false then
			set the title of button "Convert" of box "Progress Box" of window "window" to "Cancel"
			set mainRunning to true
			tell progress indicator "Progress Bar" of box "Progress Box" of window "window" to start
			if FilesNotFolders is 1 then
				--get the posix path
				set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Converting File"
				set theInFolderPosix to the POSIX path of theinfile
				set theOutFolderP to the POSIX path of theOutFolder
				tell application "Finder" to set theName to the name of file theinfile
				if theName ends with "wma" then
					set theName to (items 1 thru -4 of theName as string) & "mp3"
					with timeout of 999 seconds
						if bitrate is 0 then
							do shell script ("/opt/local/bin/ffmpeg -y -i \"" & theInFolderPosix & "\" \"" & theOutFolderP & theName & "\" -ac 2 -map_meta_data true ")
						else
							do shell script ("/opt/local/bin/ffmpeg -y -i \"" & theInFolderPosix & "\" -ab " & bitrate & " \"" & theOutFolderP & theName & "\" -ac 2 -map_meta_data true ")
						end if
					end timeout
					if importMP3 is 1 then
						set theFile to theOutFolder & theName
						tell application "iTunes"
							add file theFile to playlist iTunesLibraryPl of source iTunesLibraryPl
						end tell
					end if
					if deleteSource is 1 then
						do shell script ("rm " + theInFolderPosix)
					end if
					set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Finished"
				else
					set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Error - File isn't wma"
				end if
				set the title of button "Convert" of box "Progress Box" of window "window" to "Convert"
			else
				set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Starting..."
				set theinfolder2 to theInFolder
				my processFolder(theinfolder2)
				set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Finished"
				set the title of button "Convert" of box "Progress Box" of window "window" to "Convert"
			end if
			tell progress indicator "Progress Bar" of box "Progress Box" of window "window" to stop
			set the title of button "Convert" of box "Progress Box" of window "window" to "Convert"
			set mainRunning to true
		else
			set the title of button "Convert" of box "Progress Box" of window "window" to "Convert"
			tell progress indicator "Progress Bar" of box "Progress Box" of window "window" to stop
			set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to "Conversion Cancelled"
			set mainRunning to false
		end if
	end if
end clicked
on processFolder(theinfolder2)
	tell application "Finder"
		set FileList to every file of folder theinfolder2
		set FileNameList to the name of every file of folder theinfolder2
	end tell
	set theOutFolderP to the POSIX path of theOutFolder
	set tc to 1
	if the (count of FileNameList) is not 0 then
		repeat the count of FileNameList times
			if item tc of FileNameList ends with "wma" then
				--found a wma for conversion
				set WMACounter to WMACounter + 1
				set theName to item tc of FileNameList
				--updating text box
				set the contents of text field "Tracks Converted" of box "Progress Box" of window "window" to ("Converting File '" & theName & "'")
				set theName to (items 1 thru -4 of theName as string) & "mp3"
				set theInFolderPosix to the POSIX path of (item tc of FileList as string)
				with timeout of 999 seconds
					if bitrate is 0 then
						do shell script ("/opt/local/bin/ffmpeg -y -i \"" & theInFolderPosix & "\" \"" & theOutFolderP & theName & "\" -ac 2 -map_meta_data true ")
					else
						do shell script ("/opt/local/bin/ffmpeg -y -i \"" & theInFolderPosix & "\" -ab " & bitrate & " \"" & theOutFolderP & theName & "\" -ac 2 -map_meta_data true ")
					end if
				end timeout
				if importMP3 is 1 then
					set theFile to (theOutFolder & theName)
					tell application "iTunes"
						add file theFile to playlist iTunesLibraryPl of source iTunesLibraryPl
					end tell
					set theFile to null
				end if
				if deleteSource is 1 then
					do shell script ("rm \"" & theInFolderPosix & "\"")
				end if
				set theInFolderPosix to null
				set theName to null
			end if
			set tc to tc + 1
		end repeat
	end if
	set theOutFolderP to null
	set FileNameList to null
	set FileList to null
	if SubFolders is 1 or SubFolders is true then
		tell application "Finder" to set folderlist to every folder of folder theinfolder2
		repeat with thefolder in folderlist
			set thefolder to thefolder as string
			my processFolder(thefolder)
			set thefolder to null
		end repeat
		set folderlist to null
	end if
end processFolder
on will finish launching theObject
	awake from nib "Window"
	--read in user defaults
	tell application "iTunes" to set iTunesLibraryPl to the name of some library playlist
	try
		set Prefs to contents of default entry "Prefs" of user defaults
		set importMP3 to item 1 of Prefs
		set deleteSource to item 2 of Prefs
		set theInFolder to item 3 of Prefs
		set theinfile to item 4 of Prefs
		set theOutFolder to item 5 of Prefs
		set SubFolders to item 6 of Prefs
		set FilesNotFolders to item 7 of Prefs
		set theVal to item 8 of Prefs
	on error
		make new default entry at end of default entries of user defaults with properties {name:"Prefs", contents:{false, false, "", "", "", false, 0, 2.0}}
	end try
	if theinfile is not "" then
		set the contents of text field "Input File String" of box "IFBox" of tab view item "Files" of tab view "Tabs" of window "Window" to theinfile
	end if
	if theInFolder is not "" then
		set the contents of text field "Input Folder String" of box "IFBox" of tab view item "Folders" of tab view "Tabs" of window "Window" to theInFolder
	end if
	if theOutFolder is not "" then
		set the contents of text field "Output Folder String" of box "OFBox" of window "Window" to theOutFolder
	end if
	if FilesNotFolders is 1 then
		tell tab view "tabs" of window "window"
			set current tab view item to tab view item "files"
		end tell
	else
		tell tab view "tabs" of window "window"
			set current tab view item to tab view item "folders"
		end tell
	end if
	--setting up buttons/text fields as from user defaults
	set the state of the button "Include Sub-Folders" of tab view item "Folders" of tab view "tabs" of window "Window" to SubFolders
	set the state of the button "Import Mp3" of window "window" to importMP3
	set the state of the button "Delete Source" of window "window" to deleteSource
	set the contents of slider "BitRateChanger" of window "window" to theVal
	--Text display for theVal
	if theVal is 0.0 then set bitrate to 64
	if theVal is 1.0 then set bitrate to 96
	if theVal is 2.0 then set bitrate to 128
	if theVal is 3.0 then set bitrate to 160
	if theVal is 4.0 then set bitrate to 192
	if theVal is 5.0 then set bitrate to 224
	if theVal is 6.0 then set bitrate to 256
	if theVal is 7.0 then set bitrate to 320
	if theVal is 8.0 then
		set bitrate to 0
		set the content of text field "bitrate2Disp" of window "Window" to "Keeping current bitrate"
	else
		set the content of text field "bitrate2Disp" of window "Window" to (bitrate & " kbps" as string)
	end if
	--end text display
	set visible of window "window" to true
end will finish launching

on will quit theObject
	--write out user defaults
	set the contents of default entry "Prefs" of user defaults to {importMP3, deleteSource, theInFolder, theinfile, theOutFolder, SubFolders, FilesNotFolders, theVal}
	--to remove defaults for distribution
	--set the contents of default entry "Prefs" of user defaults to {false, false, "", "", "", false, 0, 2.0} 
end will quit
on should quit after last window closed theObject
	return true
end should quit after last window closed
on action theObject
	set theVal to the content of theObject
	if theVal is 0.0 then set bitrate to 64
	if theVal is 1.0 then set bitrate to 96
	if theVal is 2.0 then set bitrate to 128
	if theVal is 3.0 then set bitrate to 160
	if theVal is 4.0 then set bitrate to 192
	if theVal is 5.0 then set bitrate to 224
	if theVal is 6.0 then set bitrate to 256
	if theVal is 7.0 then set bitrate to 320
	if theVal is 8.0 then
		set bitrate to 0
		set the content of text field "bitrate2Disp" of window "Window" to "Keeping current bitrate"
	else
		set the content of text field "bitrate2Disp" of window "Window" to (bitrate & " kbps" as string)
	end if
end action
on will select tab view item theObject tab view item tabViewItem
	if the window "window" is visible then
		if the name of the current tab view item of tab view "Tabs" of window "Window" is "Files" then
			set FilesNotFolders to 0
		else
			set FilesNotFolders to 1
		end if
	end if
end will select tab view item


